var ResetSearchbar = {
    
    init: function()
    {
        this.searchbar = document.getElementById("searchbar");
        
        this.searchbar._engineButton.addEventListener('click', this._onClickOnButton, false);
        
        this.pref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefService)
                        .getBranch("extensions.ResetSearchbar.");
        this.pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
        
        document.getElementById('Web Search with Default Engine')
                .setAttribute('key', this.pref.getCharPref('webSearchWithDefaultEngine.key'));
    },
  
    resetEngine: function()
    {
        this.searchbar.currentEngine = this.searchbar._engines[0];
    },
       
    webSearchWithDefaultEngine: function()
    {
        this.resetEngine();
        this.searchbar.focus();
    },       
    
    set searchtext (value)
    {
        if (!value) value = '';
        this.searchbar.value = value;
	    this.searchbar.empty = (value == '');
        var inputEvent = document.createEvent('Events');
        if (inputEvent) {
            inputEvent.initEvent('oninput', true, true);
            this.searchbar.dispatchEvent(inputEvent);
        }
    },
    
    get searchtext ()
    {
        return this.searchbar.value;
    },
        
    _onClickOnButton: function(event)
    {
        if (event.button != 1) return;
        if (event.target !== event.currentTarget) return;
        const me = ResetSearchbar;
        if (me.pref.getBoolPref('engineButtonMidClick.resetEngine'))
            me.resetEngine();
        if (me.pref.getBoolPref('engineButtonMidClick.focus'))
            me.searchbar.focus();
        if (me.pref.getBoolPref('engineButtonMidClick.clear'))
            me.searchtext = '';
    }
};

window.addEventListener("load", function (){ResetSearchbar.init();}, false);
